require 'singleton'

module Cnfg
  class Base
    include Singleton

    attr_accessor :foo, :bar

    @@settings = {}

    def initialize
      merge file.read
    end

    def merge(settings)
      begin
        settings.each_pair{|k, v| send("#{k}=", v) }
      rescue NoMethodError => e
        method = e.message.match(/`(.*)\=/)[1]
        options = defaults.keys.map{|k| ":#{k}"}.join(', ')
        puts "No configuration setting for :#{method} in\n  #{options}\n\n"
        exit(0)
      end
    end

    private

    def file
      @file ||= Cnfg::Filesystem.new(:cnfg)
    end
  end
end
