require 'yaml'

module Cnfg
  class Filesystem
    attr_reader :filename

    def initialize(filename)
      @filename = ".#{filename}rc"
    end

    def read
      return {} unless File.exists?(path)
      contents.inject({}){|m,(k,v)| m[k.to_sym] = v; m}
    end

    private

    def contents
      values = YAML.load_file(path)
      return values if values.is_a?(Hash)

      raise ArgumentError, "The specified configuration file must be YAML"
    end

    def path
      @path ||= "#{ENV['HOME']}/#{filename}"
    end
  end
end
